# -*- coding: utf-8 -*-
"""Untitled2.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1wh06APwrkJSPmAELR5copugnQyjSaWou
"""

import sys
import pandas as pd


# FEATURES = ['area', 'tang', 'ban_cong', 'san_thuong']
# FEATURES_CAT = ['addr_district', 'addr_city', 'realestate_type']
# transaction = sys.argv[1]
# city = sys.argv[2]
# district = sys.argv[3]
# area = sys.argv[4]
# real_type = sys.argv[5]
# santhuong = sys.argv[6]
# bacony = sys.argv[7]
# tang = sys.argv[8]

# import re
# cities = re.findall('[A-Z][^A-Z]*', city)
# a = " "
# cities = re.findall('[A-Z][^A-Z]*', city)
# city = a.join(cities)
# if not re.search('\d+', district):
#     # districts = re.findall('[A-Z][^A-Z]*', district)
#     # district = a.join(districts)
#     b = []
#     count = -1
#     for x in district:
#         if x.isupper():
#             count += 1
#             b.append("")
#             b[count] += x
#         else:
#             b[count] += x
#         district = a.join(b)
# else:
#     match = re.findall('quận|Quận|[0-9]+', district)
#     district = a.join(match)

# import tensorflow as tf
# engineered_features = []

# for continuous_feature in FEATURES:
#     engineered_features.append(
#         # tf.contrib.layers.real_valued_column(continuous_feature))
#         tf.feature_column.numeric_column(continuous_feature))
# for categorical_feature in FEATURES_CAT:
#     # sparse_column = tf.contrib.layers.sparse_column_with_hash_bucket(
#     #     categorical_feature, hash_bucket_size=1000)
#     sparse_column = tf.feature_column.categorical_column_with_hash_bucket(
#         categorical_feature, hash_bucket_size=1000)

#     engineered_features.append(tf.feature_column.embedding_column(categorical_column=sparse_column, dimension=4,combiner="sum"))

# def input_fn_new(data_set, training = True):
#     continuous_cols = {k: tf.constant(data_set[k].values, dtype=tf.float64) for k in FEATURES}

#     categorical_cols = {k: tf.SparseTensor(
#         indices=[[i, 0] for i in range(data_set[k].size)], values = data_set[k].values, dense_shape = [data_set[k].size, 1]) for k in FEATURES_CAT}

#     # Merges the two dictionaries into one.
#     feature_cols = dict(list(continuous_cols.items()) + list(categorical_cols.items()))

#     if training == True:
#         # Converts the label column into a constant Tensor.
#         label = tf.constant(data_set[LABEL].values)

#         # Returns the feature columns and the label.
#         return feature_cols, label

#     return feature_cols
# # import sys
# # transaction = sys.argv[1]
# # city = sys.argv[2]
# # district = sys.argv[3]
# # area = sys.argv[4]
# # real_type = sys.argv[5]
# # santhuong = sys.argv[6]
# # bacony = sys.argv[7]
# # tang = sys.argv[8]
# import os
# if transaction == "bán":
#   model_dir =  ".\\ban"
# else:
#   model_dir = ".\\mua"


# regressor = tf.estimator.DNNRegressor(feature_columns = engineered_features,
#                                           activation_fn = tf.nn.relu6, hidden_units=[1], optimizer=tf.keras.optimizers.SGD( learning_rate= 0.025), dropout=0.01,model_dir = model_dir)

# import sys

# result ={'addr_city':[city],'addr_district':[district],'realestate_type':[real_type],'area':[area],'tang':[tang],'ban_cong':[bacony],'san_thuong':[santhuong]}
# data = pd.DataFrame(result,columns= FEATURES + FEATURES_CAT)

# import itertools

def run_model(data):
    # district, balcony, real_type, transaction_type, yard, floor, city, area = data
    # print(district, balcony, real_type, transaction_type, yard, floor, city, area )

    transaction = data['transaction_type']
    city = data['city']
    district = data['district']
    area = data['area']
    real_type = data['real_type']
    santhuong = data['yard']
    bacony = data['balcony']
    tang = data['floor']

    FEATURES = ['area', 'tang', 'ban_cong', 'san_thuong']
    FEATURES_CAT = ['addr_district', 'addr_city', 'realestate_type']

    import re
    cities = re.findall('[A-Z][^A-Z]*', city)
    a = " "
    cities = re.findall('[A-Z][^A-Z]*', city)
    city = a.join(cities)
    if not re.search('\d+', district):
        # districts = re.findall('[A-Z][^A-Z]*', district)
        # district = a.join(districts)
        b = []
        count = -1
        for x in district:
            if x.isupper():
                count += 1
                b.append("")
                b[count] += x
            else:
                b[count] += x
            district = a.join(b)
    else:
        match = re.findall('quận|Quận|[0-9]+', district)
        district = a.join(match)

    import tensorflow as tf
    engineered_features = []

    for continuous_feature in FEATURES:
        engineered_features.append(
            # tf.contrib.layers.real_valued_column(continuous_feature))
            tf.feature_column.numeric_column(continuous_feature))
    for categorical_feature in FEATURES_CAT:
        # sparse_column = tf.contrib.layers.sparse_column_with_hash_bucket(
        #     categorical_feature, hash_bucket_size=1000)
        sparse_column = tf.feature_column.categorical_column_with_hash_bucket(
            categorical_feature, hash_bucket_size=1000)

        engineered_features.append(tf.feature_column.embedding_column(categorical_column=sparse_column, dimension=4,combiner="sum"))

    def input_fn_new(data_set, training = True):
        continuous_cols = {k: tf.constant(data_set[k].values, dtype=tf.float64) for k in FEATURES}

        categorical_cols = {k: tf.SparseTensor(
            indices=[[i, 0] for i in range(data_set[k].size)], values = data_set[k].values, dense_shape = [data_set[k].size, 1]) for k in FEATURES_CAT}

        # Merges the two dictionaries into one.
        feature_cols = dict(list(continuous_cols.items()) + list(categorical_cols.items()))

        if training == True:
            # Converts the label column into a constant Tensor.
            label = tf.constant(data_set[LABEL].values)

            # Returns the feature columns and the label.
            return feature_cols, label

        return feature_cols
    # import sys
    # transaction = sys.argv[1]
    # city = sys.argv[2]
    # district = sys.argv[3]
    # area = sys.argv[4]
    # real_type = sys.argv[5]
    # santhuong = sys.argv[6]
    # bacony = sys.argv[7]
    # tang = sys.argv[8]
    import os
    if transaction == "bán":
        model_dir =  ".\\ban"
    else:
        model_dir = ".\\mua"


    regressor = tf.estimator.DNNRegressor(feature_columns = engineered_features,
                                            activation_fn = tf.nn.relu6, hidden_units=[1], optimizer=tf.keras.optimizers.SGD( learning_rate= 0.025), dropout=0.01,model_dir = model_dir)

    import sys

    result ={'addr_city':[city],'addr_district':[district],'realestate_type':[real_type],'area':[area],'tang':[tang],'ban_cong':[bacony],'san_thuong':[santhuong]}
    data = pd.DataFrame(result,columns= FEATURES + FEATURES_CAT)

    import itertools

    result = 0
    while (result < 0 or result == 0): 
        predict = regressor.predict(input_fn=lambda: input_fn_new(data, training = False))
        a =list(itertools.islice(predict, data.shape[0]))
        result = a[0]["predictions"][0]
    return result
